//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  GDI+ ֌WTv
//  PsNZ̐F̎擾ƕύX
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2017N0715 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, GDIPAPI, GDIPOBJ, GDIPUTIL, ComCtrls, ExtDlgs,
  ImgList, ToolWin;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    ImageList1: TImageList;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    Edit1: TEdit;
    ColorDialog1: TColorDialog;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure Image3MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Privat  e 錾 }
    FPixelRectSize  : Cardinal;
    FMaxImgPixels   : Integer;
    FPixelGridColor : TColor;
    FMemStream      : TBytesStream;
    FGPBitmap       : TGPBitmap;
    FBackTBitmap    : TBitmap;
    FGPUseColor     : TGPColor;
    FOperationNo    : Cardinal;
    procedure DisplayImageAndGridLine(NeedInvalidate: Boolean);
    procedure DrawUseColorToTImage(AColor: TGPColor);
  public
    { Public 錾 }
    procedure DrawPixelColorToTImage(SrcGPBitmap: TGPBitmap; DrawTimage: TImage;
      PixelRectSize: Integer; MaxImgPixels: Integer; GridLineColor: TColor;
      BackImage: TBitmap = nil; ShowGridLine: Boolean = True;
      BackGround: Boolean = True);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

const
  OPERATION_NONE = $00;
  OPERATION_GET_PIXELCOLOR = $10;
  OPERATION_SET_PIXELCOLOR = $20;

//=============================================================================
//  tH[̏
//
//  TToolBar̊eTToolButtoñvpeB̒lȉɂĂ
//  ̐ݒTToolButton.DownvpeB̒lgp\ɂȂ
//  TToolButton.Grouped := True:;
//  TToolButton.Style := tbsCheck;
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
var
  LBackGroundFile : string;
begin
  //Obh̐FƃsNZ̕`TCY
  FPixelGridColor := clGray;
  FPixelRectSize  := 12;
  FMaxImgPixels   := 128;

  Image1.Transparent := False;
  Image2.Transparent := False;
  Image3.Transparent := False;

  //wiɕ`悷iq̎s͗l̃rbg}bv摜̐ݒ
  //ߏԂmF邽߂Ɏ{p
  FBackTBitmap := TBitmap.Create;
  LBackGroundFile := ExpandFileName('.\backTexture_02.bmp');
  if FileExists(LBackGroundFile) then begin
    FBackTBitmap.LoadFromFile(LBackGroundFile);
  end else begin
    FBackTBitmap := nil;
  end;

  //Xg[ɉ摜t@Cǂݍ
  FMemStream := TBytesStream.Create;
  FMemStream.LoadFromFile('livejournal.png');

  //Xg[TGPBitmap쐬
  FGPBitmap := TGPBitmap.Create(TStreamAdapter.Create(FMemStream, soReference));

  //gpF̏l
  FGPUseColor := ColorRefToARGB(clBlack);
  DrawUseColorToTImage(FGPUseColor);

  //摜ƃsNZ̃Obh\
  DisplayImageAndGridLine(True);

  //Ƃ̎
  //TToolButton.DownvpeB̒lłǂ̃{^ꂽԂm邱Ƃł邪
  //ł͍Ɠe萔lŔ肷邱Ƃɂ
  FOperationNo := OPERATION_NONE;
end;

//=============================================================================
//  tH[j̏
//=============================================================================
procedure TForm1.FormDestroy(Sender: TObject);
begin
  if Assigned(FGPBitmap)  then FreeAndNil(FGPBitmap);
  if Assigned(FMemStream) then FreeAndNil(FMemStream);
  if Assigned(FBackTBitmap) then FreeAndNil(FBackTBitmap);
end;

//=============================================================================
//  ToolButton1OnClickCxg
//  TToolButtonƂ̋LCxg
//  e̐ݒ
//=============================================================================
procedure TForm1.ToolButton1Click(Sender: TObject);
begin
  if Sender = ToolButton1 then begin
    FOperationNo := OPERATION_NONE;
  end else
  if Sender = ToolButton2 then begin
    FOperationNo := OPERATION_SET_PIXELCOLOR;
  end else
  if Sender = ToolButton3 then begin
    FOperationNo := OPERATION_GET_PIXELCOLOR;
  end else begin
    FOperationNo := OPERATION_NONE;
  end;
end;

//=============================================================================
//  Image1OnMouseDownCxg
//  sNZ̐F̎擾܂̓sNZ̐F̕ύX
//
//  Imaae1͉摜g\sNZ̐F\p
//=============================================================================
procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  LXPos    : Integer;
  LYPos    : Integer;
begin
  if not Assigned(FGPBitmap) then exit;
  if Button <> mbLeft then exit;

  //ۂ̉摜̍Wlɕϊ
  LXPos := X div FPixelRectSize;
  LYPos := Y div FPixelRectSize;

  if FOperationNo = OPERATION_SET_PIXELCOLOR then begin
    FGPBitmap.SetPixel(LXPos, LYPos, FGPUseColor);
    DisplayImageAndGridLine(True);
  end else
  if FOperationNo = OPERATION_GET_PIXELCOLOR then begin
    FGPBitmap.GetPixel(LXPos, LYPos, FGPUseColor);
    DrawUseColorToTImage(FGPUseColor);
  end;
end;

//=============================================================================
//  Image3OnMouseDownCxg
//  FI_CAO\ăsNZ̐FύXFI
//  TColorDialog_CAOɂ̓At@l̐ݒ@\͂Ȃ
//
//  Imaae3̓sNZ̐FύXɎgpF\p̃Rg[
//=============================================================================
procedure TForm1.Image3MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ColorDialog1.Color := ARGBToColorRef(FGPUseColor);
  if ColorDialog1.Execute then begin
    FGPUseColor := ColorRefToARGB(ColorDialog1.Color);
    DrawUseColorToTImage(FGPUseColor);
  end;
end;

//-----------------------------------------------------------------------------
//  TImageւ̕`̃R[h
//  TCYƊg\pObh\
//-----------------------------------------------------------------------------
procedure TForm1.DisplayImageAndGridLine(NeedInvalidate: Boolean);
var
  LGPGraphics : TGPGraphics;
begin
  //TGPBitmapTImageɎTCYŕ`
  if NeedInvalidate then begin
    Image2.Picture.Assign(nil);
    LGPGraphics := TGPGraphics.Create(Image2.Canvas.Handle);
    LGPGraphics.DrawImage(FGPBitmap, 0, 0);
    LGPGraphics.Free;
  end;

  //sNZ̃Obh\
  DrawPixelColorToTImage(FGPBitmap, Image1, FPixelRectSize, FMaxImgPixels,
                         FPixelGridColor, FBackTBitmap);
end;

//-----------------------------------------------------------------------------
//  gpF\ĂTImaeRg[ւ̕`p[`
//-----------------------------------------------------------------------------
procedure TForm1.DrawUseColorToTImage(AColor: TGPColor);
var
  LGPGraphic : TGPGraphics;
  LGPBrush   : TGPSolidBrush;
  LGPRect    : TGPRect;
begin
  Image3.Picture.Assign(nil);
  //TGPSolidBrush𐶐
  LGPBrush := TGPSolidBrush.Create(AColor);
  //`TImageɂTGPGraphics.Create
  LGPGraphic := TGPGraphics.Create(Image3.Canvas.Handle);
  try
    //`hׂ`
    LGPRect := MakeRect(0, 0, Image3.Width, Image3.Height);
    LGPGraphic.FillRectangle(LGPBrush, LGPRect);
  finally
    FreeAndNil(LGPGraphic);
    FreeAndNil(LGPBrush);
  end;
  Edit1.Text := '$' + IntToHex(AColor, 8);
end;

//-----------------------------------------------------------------------------
//  TGPBitmap̊esNZ̐FObh\
//-----------------------------------------------------------------------------
procedure TForm1.DrawPixelColorToTImage(SrcGPBitmap: TGPBitmap;
  DrawTimage: TImage; PixelRectSize: Integer;  MaxImgPixels: Integer;
  GridLineColor: TColor; BackImage: TBitmap = nil; ShowGridLine: Boolean = True;
  BackGround: Boolean = True);
type
  TRGBQArray = array [0..4095] of RGBQUAD;
  PRGBQArray = ^TRGBQArray;
var
  LSrcImgWidth  : Integer;
  LSrcImgHeight : Integer;
  LImgWidth     : Integer;
  LImgHeight    : Integer;
  LBmpData      : TBitmapData;
  LScanLine     : PByte;
  LpRGBQuad     : PRGBQuad;
  LDataStride   : Integer;
  LAValue       : Byte;
  LRValue       : Byte;
  LGValue       : Byte;
  LBValue       : Byte;
  LXPos         : Integer;
  LYPos         : Integer;
  LImgBitmap    : TBitmap;
  LDstScanArray : PRGBQArray;
  LiiX          : Integer;
  LiiY          : Integer;
  LGridRValue   : Byte;
  LGridGValue   : Byte;
  LGridBValue   : Byte;
  LBitmap       : TBitmap;
begin
  DrawTimage.Picture.Assign(nil);

  //摜̃TCY擾
  LSrcImgWidth  := SrcGPBitmap.GetWidth;
  LSrcImgHeight := SrcGPBitmap.GetHeight;
  if LSrcImgWidth > MaxImgPixels  then LSrcImgWidth  := MaxImgPixels;
  if LSrcImgHeight > MaxImgPixels then LSrcImgHeight := MaxImgPixels;

  //Obh\̕`TCY
  LImgWidth  := LSrcImgWidth * PixelRectSize + 1;
  LImgHeight := LSrcImgHeight * PixelRectSize + 1;

  //wi摜̎w肪Ε`
  if (Assigned(BackImage)) and BackGround then begin
    DrawTimage.Canvas.Brush.Bitmap := BackImage;
    DrawTimage.Canvas.FillRect(DrawTimage.ClientRect);
  end;


  //TGPBitmap̃rbg}bvf[^擾
  if SrcGPBitmap.LockBits(MakeRect(0, 0, LSrcImgWidth, LSrcImgHeight),
             ImageLockModeRead, PixelFormat32bppARGB, LBmpData) <> Ok then exit;

  //sNZƃObh`悷TBitmap쐬
  //ɕ`悵TImageCanvasɕ`悷
  LImgBitmap := TBitmap.Create;
  try
    LImgBitmap.SetSize(LImgWidth, LImgHeight);
    LImgBitmap.PixelFormat := pf32bit;
    //AlphaFormat := afIgnoredƂĂ
    //afIgnoredɂȂĔ̃sNZɕ`łȂ
    //TImage.Canvasɕ`悷鎞afDefinedɂ
    LImgBitmap.AlphaFormat := afIgnored;

    LScanLine   := LBmpData.Scan0;
    LDataStride := LBmpData.Stride;

    //Obh̐FRGBl擾Ă
    LGridRValue := GetRValue(GridLineColor);
    LGridGValue := GetGValue(GridLineColor);
    LGridBValue := GetBValue(GridLineColor);

    for LYPos := 0 to LSrcImgHeight - 1 do begin
      LpRGBQuad := PRGBQuad(LScanLine);
      LImgBitmap.Canvas.Lock;

      for LXPos := 0 to LSrcImgWidth - 1 do begin

        LAValue := LpRGBQuad^.rgbReserved;
        LRValue := LpRGBQuad^.rgbRed;
        LGValue := LpRGBQuad^.rgbGreen;
        LBValue := LpRGBQuad^.rgbBlue;

        for LiiY := 0 to PixelRectSize do begin
          LDstScanArray  := LImgBitmap.ScanLine[LYPos * PixelRectSize + LiiY];

          //̕Obhւ̕`
          for LiiX := 0 to PixelRectSize do begin
            //Obh`悷Wl̎
            if (ShowGridLine) and ((LiiY = 0) or (LiiX = 0) or
              (LiiY = PixelRectSize) or (LiiX = PixelRectSize)) then begin
              LDstScanArray[LXPos * PixelRectSize + LiiX].rgbReserved := $FF;
              LDstScanArray[LXPos * PixelRectSize + LiiX].rgbRed      := LGridRValue;
              LDstScanArray[LXPos * PixelRectSize + LiiX].rgbGreen    := LGridGValue;
              LDstScanArray[LXPos * PixelRectSize + LiiX].rgbBlue     := LGridBValue;
            end else begin
              LDstScanArray[LXPos * PixelRectSize + LiiX].rgbReserved := LAValue;
              LDstScanArray[LXPos * PixelRectSize + LiiX].rgbRed      := LRValue;
              LDstScanArray[LXPos * PixelRectSize + LiiX].rgbGreen    := LGValue;
              LDstScanArray[LXPos * PixelRectSize + LiiX].rgbBlue     := LBValue;
            end;
          end;
        end;

        Inc(LpRGBQuad);
      end;
      Inc(LScanLine, LDataStride);
    end;

    //쐬TBitmapTImageCanvasɕ`
    //AlphaFormat := afDefinedɂĔ摜̃sNZŕ\
    DrawTimage.Picture.Bitmap.SetSize(LImgWidth, LImgHeight);
    LImgBitmap.AlphaFormat := afDefined;
    DrawTimage.Canvas.Draw(0, 0, LImgBitmap);
  finally
    SrcGPBitmap.UnlockBits(LBmpData);
    LImgBitmap.Canvas.Unlock;

    FreeAndNil(LImgBitmap);
  end;
end;

end.
