//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  GDI+ ֌WTv
//  }EXŃNbN̈̓hׂ
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2017N0715 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, GDIPAPI, GDIPOBJ, GDIPUTIL, ComCtrls, ExtDlgs,
  ImgList, ToolWin;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Image2: TImage;
    ImageList1: TImageList;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    Edit1: TEdit;
    ColorDialog1: TColorDialog;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure Image2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Privat  e 錾 }
    FMemStream      : TBytesStream;
    FGPBitmap       : TGPBitmap;
    FBackTBitmap    : TBitmap;
    FDispImgWidth   : Integer;
    FDispImgHeight  : Integer;
    FGPUseColor     : TGPColor;
    FOperationNo    : Cardinal;
    procedure DisplayImageToTImage;
    procedure DrawUseColorToTImage(AColor: TGPColor);
    function SetAlphaValueFromTBitmap(DstGPBitmap: TGPBitmap;
      SrcBitmap: TBitmap): Boolean;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

const
  OPERATION_NONE = $00;
  OPERATION_PAINT_FLOODFILL = $100;

//=============================================================================
//  tH[̏
//
//  TToolBar̊eTToolButtoñvpeB̒lȉɂĂ
//  ̐ݒTToolButton.DownvpeB̒lgp\ɂȂ
//  TToolButton.Grouped := True:;
//  TToolButton.Style := tbsCheck;
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
var
  LBackGroundFile : string;
begin
  Image1.Transparent := False;
  Image2.Transparent := False;

  //wiɕ`悷iq̎s͗l̃rbg}bv摜̐ݒ
  //ߏԂmF邽߂Ɏ{p
  FBackTBitmap := TBitmap.Create;
  LBackGroundFile := ExpandFileName('.\backTexture_01.bmp');
  if FileExists(LBackGroundFile) then begin
    FBackTBitmap.LoadFromFile(LBackGroundFile);
  end else begin
    FBackTBitmap := nil;
  end;

  //Xg[ɉ摜t@Cǂݍ
  FMemStream := TBytesStream.Create;
  FMemStream.LoadFromFile('502.png');

  //TCYw肵ĉ摜`
  FGPBitmap := TGPBitmap.Create(TStreamAdapter.Create(FMemStream, soReference));

  //摜ƃsNZ̃Obh\
  FDispImgWidth  := 250;
  FDispImgHeight := Trunc(FDispImgWidth * FGPBitmap.GetHeight / FGPBitmap.GetWidth);
  DisplayImageToTImage;

  //gpF̏l
  FGPUseColor := ColorRefToARGB(clBlack);
  DrawUseColorToTImage(FGPUseColor);

  //Ƃ̎
  //TToolButton.DownvpeB̒lłǂ̃{^ꂽԂm邱Ƃł邪
  //ł͍Ɠe萔lŔ肷邱Ƃɂ
  FOperationNo := OPERATION_NONE;
end;

//=============================================================================
//  tH[j̏
//=============================================================================
procedure TForm1.FormDestroy(Sender: TObject);
begin
  if Assigned(FGPBitmap)  then FreeAndNil(FGPBitmap);
  if Assigned(FMemStream) then FreeAndNil(FMemStream);
  if Assigned(FBackTBitmap) then FreeAndNil(FBackTBitmap);
end;

//=============================================================================
//  ToolButton1OnClickCxg
//  TToolButtonƂ̋LCxg
//  e̐ݒ
//=============================================================================
procedure TForm1.ToolButton1Click(Sender: TObject);
begin
  if Sender = ToolButton1 then begin
    FOperationNo := OPERATION_NONE;
  end else
  if Sender = ToolButton2 then begin
    FOperationNo := OPERATION_PAINT_FLOODFILL;
  end;
end;

//=============================================================================
//  Image1OnMouseDownCxg
//  NbNsNZ̗̈̐FύX
//
//  GDI+ɂGDIFloodFill̓@\̃\bhȂ
//  GDI(VCL)TBitmap쐬FloodFillgpď
//  ̕@EMF,WMF̃xN^摜͐ɏłȂ
//  w肷ƓFɂȂ
//=============================================================================
procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  LGPGraphics    : TGPGraphics;
  LGPBitmap      : TGPBitmap;
  LGPTargetColor : TGPColor;
  LTargetColor   : TColor;
  LChangedColor  : TColor;
  LBitmap        : TBitmap;
  LhBitmap       : HBITMAP;
begin
  if not Assigned(FGPBitmap) then exit;
  if Button <> mbLeft then exit;


  if FOperationNo = OPERATION_PAINT_FLOODFILL then begin

    //݂̕`TCYƓTCYTGPBitmap쐬
    if (FGPBitmap.GetWidth <> FDispImgWidth)
      or (FGPBitmap.GetHeight <> FDispImgHeight) then begin

      LGPBitmap := TGPBitmap.Create(FDispImgWidth, FDispImgHeight);
      LGPGraphics := TGPGraphics.Create(LGPBitmap);
      try
        LGPGraphics.DrawImage(FGPBitmap,
                              MakeRect(0, 0, FDispImgWidth, FDispImgHeight),
                              0,
                              0,
                              FGPBitmap.GetWidth,
                              FGPBitmap.GetHeight,
                              UnitPixel);
         //FGPBitmapݕ\̃TCYɂȂ
         FGPBitmap := TGPBitmap(LGPBitmap.Clone);
      finally
        FreeAndNil(LGPBitmap);
      end;
    end;

    LBitmap := TBitmap.Create;
    try
      LBitmap.PixelFormat := pf32bit;
      LBitmap.AlphaFormat := afDefined;

      //摜rbg}bvŎ擾
      FGPBitmap.GetHBITMAP(0, LhBitmap);
      LBitmap.Handle := LhBitmap;
      LBitmap.AlphaFormat := afIgnored;

      //hׂ
      FGPBitmap.GetPixel(X, Y, LGPTargetColor);

      LTargetColor  := ARGBToColorRef(LGPTargetColor);
      LChangedColor := ARGBToColorRef(FGPUseColor);

      LBitmap.Canvas.Brush.Color := LChangedColor;
      LBitmap.Canvas.FloodFill(X, Y, LTargetColor, fsSurface);

      //TBitmapTGPBitmap쐬
      //TGPBitmapTGPBitmapƂƂɂȂ
      FMemStream.Clear;
      FreeAndNil(FGPBitmap);

      LBitmap.SaveToStream(FMemStream);

      FGPBitmap := TGPBitmap.Create(TStreamAdapter.Create(FMemStream, soReference));
      //At@`l悤ɂ
      SetAlphaValueFromTBitmap(FGPBitmap, LBitmap);
      DisplayImageToTImage;
    finally
      FreeAndNil(LBitmap);
    end;

  end;
end;

//=============================================================================
//  Image3OnMouseDownCxg
//  FI_CAO\ăsNZ̐FύXɎgpFI
//  TColorDialog_CAOɂ̓At@l̐ݒ@\͂Ȃ
//
//  Imaae2̓sNZ̐FύXɎgpF\p̃Rg[
//=============================================================================
procedure TForm1.Image2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ColorDialog1.Color := ARGBToColorRef(FGPUseColor);
  if ColorDialog1.Execute then begin
    FGPUseColor := ColorRefToARGB(ColorDialog1.Color);
    DrawUseColorToTImage(FGPUseColor);
  end;
end;

//-----------------------------------------------------------------------------
//  TImageւ̕`̃R[h
//-----------------------------------------------------------------------------
procedure TForm1.DisplayImageToTImage;
var
  LGPGraphics : TGPGraphics;
begin
  Image1.Picture.Assign(nil);
  Image1.Picture.Bitmap.SetSize(FDispImgWidth, FDispImgHeight);
  LGPGraphics := TGPGraphics.Create(Image1.Canvas.Handle);
  try
    //wi摜̎w肪Ε`
    if Assigned(FBackTBitmap) then begin
      Image1.Canvas.Brush.Bitmap := FBackTBitmap;
      Image1.Canvas.FillRect(Image1.ClientRect);
    end;

    LGPGraphics.DrawImage(FGPBitmap,
                          MakeRect(0, 0, FDispImgWidth, FDispImgHeight),
                          0,
                          0,
                          FGPBitmap.GetWidth,
                          FGPBitmap.GetHeight,
                          UnitPixel);
  finally
    FreeAndNil(LGPGraphics);
  end;
end;

//-----------------------------------------------------------------------------
//  gpF\ĂTImaeRg[ւ̕`p[`
//-----------------------------------------------------------------------------
procedure TForm1.DrawUseColorToTImage(AColor: TGPColor);
var
  LGPGraphic : TGPGraphics;
  LGPBrush   : TGPSolidBrush;
  LGPRect    : TGPRect;
begin
  Image2.Picture.Assign(nil);
  //TGPSolidBrush𐶐
  LGPBrush := TGPSolidBrush.Create(AColor);
  //`TImageɂTGPGraphics.Create
  LGPGraphic := TGPGraphics.Create(Image2.Canvas.Handle);
  try
    //`hׂ`
    LGPRect := MakeRect(0, 0, Image2.Width, Image2.Height);
    LGPGraphic.FillRectangle(LGPBrush, LGPRect);
  finally
    FreeAndNil(LGPGraphic);
    FreeAndNil(LGPBrush);
  end;
  Edit1.Text := '$' + IntToHex(AColor, 8);
end;

//-----------------------------------------------------------------------------
//  ǂݍ񂾃rbg}bv(TBitmap)摜̃At@l̏
//
//  TGPBitmapTBitmap̃At@`lȂ
//  TBitmap̃At@lTGPBitmap̃At@lɑ
//  At@`ltTBitmapAt@`ltŕ\\ɂ
//  ̃rbg[32bitȏp
//-----------------------------------------------------------------------------
function TForm1.SetAlphaValueFromTBitmap(DstGPBitmap: TGPBitmap;
  SrcBitmap: TBitmap): Boolean;
type
  TRGBQArray = array [0..4095] of RGBQUAD;
  PRGBQArray = ^TRGBQArray;
var
  LBmpData    : TBitmapData;
  LScanLine   : PByte;
  LpRGBQuad   : PRGBQuad;
  LWidth      : Integer;
  LHeight     : Integer;
  LDataStride : Integer;
  LXPos       : integer;
  LYPos       : Integer;
  LScanArray  : PRGBQArray;
  LAValue     : Byte;
  LRValue     : Byte;
  LGValue     : Byte;
  LBValue     : Byte;
begin
  Result := False;

  LWidth  := DstGPBitmap.GetWidth;
  LHeight := DstGPBitmap.GetHeight;

  //TGPBitmap̃rbg}bvf[^擾
  if DstGPBitmap.LockBits(MakeRect(0, 0, LWidth, LHeight), ImageLockModeWrite,
                                 PixelFormat32bppARGB, LBmpData) <> Ok then exit;

  SrcBitmap.Canvas.Lock;

  LScanLine   := LBmpData.Scan0;
  LDataStride := LBmpData.Stride;

  for LYPos := 0 to LHeight - 1 do begin
    LpRGBQuad  := PRGBQuad(LScanLine);
    LScanArray := SrcBitmap.ScanLine[LYPos];

    for LXPos := 0 to LWidth - 1 do begin

      LAValue := LScanArray[LXPos].rgbReserved;
      LRValue := LScanArray[LXPos].rgbRed;
      LGValue := LScanArray[LXPos].rgbGreen;
      LBValue := LScanArray[LXPos].rgbBlue;

      if MakeColor(LRValue, LGValue, LBValue, LAValue) = 0 then begin
        LpRGBQuad^.rgbReserved :=  0;
      end else
      if (LAValue = 0) then begin
        LpRGBQuad^.rgbReserved := $FF;
      end else begin
        LpRGBQuad^.rgbReserved := LScanArray[LXPos].rgbReserved;
      end;
      Inc(LpRGBQuad);
    end;
    Inc(LScanLine, LDataStride);
  end;

  Result := True;
  SrcBitmap.Canvas.Unlock;
  DstGPBitmap.UnlockBits(LBmpData);
end;

end.
