//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  GDI+ ֌WTv
//  TColorMap gpsNZ̐F̕ύX
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2017N0715 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, GDIPAPI, GDIPOBJ, GDIPUTIL, ComCtrls, ExtDlgs,
  ImgList, ToolWin;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Image2: TImage;
    ImageList1: TImageList;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    Edit1: TEdit;
    ColorDialog1: TColorDialog;
    ToolButton3: TToolButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure Image2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ToolButton3Click(Sender: TObject);
  private
    { Privat  e 錾 }
    FMemStream      : TBytesStream;
    FGPBitmap       : TGPBitmap;
    FBackTBitmap    : TBitmap;
    FDispImgWidth   : Integer;
    FDispImgHeight  : Integer;
    FGPUseColor     : TGPColor;
    FOperationNo    : Cardinal;
    procedure DisplayImageToTImage;
    procedure DrawUseColorToTImage(AColor: TGPColor);
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

//-----------------------------------------------------------
//  GifImagɂTColorMap̒`
//  GifImaggp邱Ƃ邩mȂ̂łŒ`
//-----------------------------------------------------------
type
  ColorMap = packed record
    oldColor: TGPColor;
    newColor: TGPColor;
  end;
  TColorMap = ColorMap;
  PColorMap = ^TColorMap;

const
  OPERATION_NONE = $00;
  OPERATION_PAINT_COLORMAP = $300;

//=============================================================================
//  tH[̏
//
//  TToolBar̊eTToolButtoñvpeB̒lȉɂĂ
//  (ToolButton3)
//  ̐ݒTToolButton.DownvpeB̒lgp\ɂȂ
//  TToolButton.Grouped := True:;
//  TToolButton.Style := tbsCheck;
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
var
  LBackGroundFile : string;
begin
  Image1.Transparent := False;
  Image2.Transparent := False;

  //wiɕ`悷iq̎s͗l̃rbg}bv摜̐ݒ
  //ߏԂmF邽߂Ɏ{p
  FBackTBitmap := TBitmap.Create;
  LBackGroundFile := ExpandFileName('.\backTexture_01.bmp');
  if FileExists(LBackGroundFile) then begin
    FBackTBitmap.LoadFromFile(LBackGroundFile);
  end else begin
    FBackTBitmap := nil;
  end;

  //Xg[ɉ摜t@Cǂݍ
  FMemStream := TBytesStream.Create;
  FMemStream.LoadFromFile('502.png');

  //Xg[TGPBitmap쐬
  FGPBitmap := TGPBitmap.Create(TStreamAdapter.Create(FMemStream, soReference));

  //TCYw肵ĉ摜`
  FDispImgWidth  := 250;
  FDispImgHeight := Trunc(FDispImgWidth * FGPBitmap.GetHeight / FGPBitmap.GetWidth);
  DisplayImageToTImage;

  //gpF̏l
  FGPUseColor := ColorRefToARGB(clBlack);
  DrawUseColorToTImage(FGPUseColor);

  //Ƃ̎
  //TToolButton.DownvpeB̒lłǂ̃{^ꂽԂm邱Ƃł邪
  //ł͍Ɠe萔lŔ肷邱Ƃɂ
  FOperationNo := OPERATION_NONE;
end;

//=============================================================================
//  tH[j̏
//=============================================================================
procedure TForm1.FormDestroy(Sender: TObject);
begin
  if Assigned(FGPBitmap)  then FreeAndNil(FGPBitmap);
  if Assigned(FMemStream) then FreeAndNil(FMemStream);
  if Assigned(FBackTBitmap) then FreeAndNil(FBackTBitmap);
end;

//=============================================================================
//  ToolButton1OnClickCxg
//  TToolButtonƂ̋LCxg
//  (ToolButton3)
//  e̐ݒ
//=============================================================================
procedure TForm1.ToolButton1Click(Sender: TObject);
begin
  if Sender = ToolButton1 then begin
    FOperationNo := OPERATION_NONE;
  end else
  if Sender = ToolButton2 then begin
    FOperationNo := OPERATION_PAINT_COLORMAP;
  end;
end;

//=============================================================================
//  ToolButton3OnClickCxg
//  摜Cǂݍ񂾎̏Ԃɖ߂
//=============================================================================
procedure TForm1.ToolButton3Click(Sender: TObject);
begin
  if not Assigned(FGPBitmap) then exit;

   FreeAndNil(FGPBitmap);
   FGPBitmap := TGPBitmap.Create(TStreamAdapter.Create(FMemStream, soReference));
   //`
   DisplayImageToTImage;
end;

//=============================================================================
//  Image1OnMouseDownCxg
//  NbNsNZƓF̃sNZύX
//=============================================================================
procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  LGPGraphics    : TGPGraphics;
  LGPBitmap      : TGPBitmap;
  LGPTargetColor : TGPColor;
  LGPImageAttr   : TGPImageAttributes;
  LGPColorMap    : array of TColorMap;
begin
  if not Assigned(FGPBitmap) then exit;
  if Button <> mbLeft then exit;


  if FOperationNo = OPERATION_PAINT_COLORMAP then begin

    //݂̕`TCYƓTCYTGPBitmap쐬
    if (FGPBitmap.GetWidth <> FDispImgWidth)
      or (FGPBitmap.GetHeight <> FDispImgHeight) then begin

      LGPBitmap := TGPBitmap.Create(FDispImgWidth, FDispImgHeight);
      LGPGraphics := TGPGraphics.Create(LGPBitmap);
      try
        LGPGraphics.DrawImage(FGPBitmap,
                              MakeRect(0, 0, FDispImgWidth, FDispImgHeight),
                              0,
                              0,
                              FGPBitmap.GetWidth,
                              FGPBitmap.GetHeight,
                              UnitPixel);
         //FGPBitmapݕ\̃TCYɂȂ
         FGPBitmap := TGPBitmap(LGPBitmap.Clone);
      finally
        FreeAndNil(LGPBitmap);
      end;
    end;


    //J[}bv̐ݒ
    FGPBitmap.GetPixel(X, Y, LGPTargetColor);
    SetLength(LGPColorMap, 1);
    LGPColorMap[0].oldColor := LGPTargetColor;
    LGPColorMap[0].newColor := FGPUseColor;

    //ݒ肵Ō݂TGPBitmapɕ`悷
    LGPBitmap    := TGPBitmap(FGPBitmap.Clone);
    LGPImageAttr := TGPImageAttributes.Create;
    LGPGraphics  := TGPGraphics.Create(FGPBitmap);
    try
      LGPImageAttr.SetRemapTable(Length(LGPColorMap), @LGPColorMap[0]);
      LGPGraphics.DrawImage(LGPBitmap,
                            MakeRect(0, 0, LGPBitmap.GetWidth, LGPBitmap.GetHeight),
                            0,
                            0,
                            FGPBitmap.GetWidth,
                            FGPBitmap.GetHeight,
                            UnitPixel,
                            LGPImageAttr);
    finally
      FreeAndNil(LGPGraphics);
      FreeAndNil(LGPBitmap);
      FreeAndNil(LGPImageAttr);
    end;

    //ύXʂ`
    DisplayImageToTImage;
  End;
end;

//=============================================================================
//  Image3OnMouseDownCxg
//  FI_CAO\ăsNZ̐FύXɎgpFI
//  TColorDialog_CAOɂ̓At@l̐ݒ@\͂Ȃ
//
//  Imaae2̓sNZ̐FύXɎgpF\p̃Rg[
//=============================================================================
procedure TForm1.Image2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ColorDialog1.Color := ARGBToColorRef(FGPUseColor);
  if ColorDialog1.Execute then begin
    FGPUseColor := ColorRefToARGB(ColorDialog1.Color);
    DrawUseColorToTImage(FGPUseColor);
  end;
end;

//-----------------------------------------------------------------------------
//  TImageւ̕`̃R[h
//-----------------------------------------------------------------------------
procedure TForm1.DisplayImageToTImage;
var
  LGPGraphics : TGPGraphics;
begin
  Image1.Picture.Assign(nil);
  Image1.Picture.Bitmap.SetSize(FDispImgWidth, FDispImgHeight);
  LGPGraphics := TGPGraphics.Create(Image1.Canvas.Handle);
  try
    //wi摜̎w肪Ε`
    if Assigned(FBackTBitmap) then begin
      Image1.Canvas.Brush.Bitmap := FBackTBitmap;
      Image1.Canvas.FillRect(Image1.ClientRect);
    end;

    LGPGraphics.DrawImage(FGPBitmap,
                          MakeRect(0, 0, FDispImgWidth, FDispImgHeight),
                          0,
                          0,
                          FGPBitmap.GetWidth,
                          FGPBitmap.GetHeight,
                          UnitPixel);
  finally
    FreeAndNil(LGPGraphics);
  end;
end;

//-----------------------------------------------------------------------------
//  gpF\ĂTImaeRg[ւ̕`p[`
//-----------------------------------------------------------------------------
procedure TForm1.DrawUseColorToTImage(AColor: TGPColor);
var
  LGPGraphic : TGPGraphics;
  LGPBrush   : TGPSolidBrush;
  LGPRect    : TGPRect;
begin
  Image2.Picture.Assign(nil);
  //TGPSolidBrush𐶐
  LGPBrush := TGPSolidBrush.Create(AColor);
  //`TImageɂTGPGraphics.Create
  LGPGraphic := TGPGraphics.Create(Image2.Canvas.Handle);
  try
    //`hׂ`
    LGPRect := MakeRect(0, 0, Image2.Width, Image2.Height);
    LGPGraphic.FillRectangle(LGPBrush, LGPRect);
  finally
    FreeAndNil(LGPGraphic);
    FreeAndNil(LGPBrush);
  end;
  Edit1.Text := '$' + IntToHex(AColor, 8);
end;

end.
