//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  GDI+ ֌WTv
//  }EẌړOՂɉ`
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2017N0715 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, GDIPAPI, GDIPOBJ, GDIPUTIL, ComCtrls, ExtDlgs,
  ImgList, ToolWin;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Image2: TImage;
    ImageList1: TImageList;
    Edit1: TEdit;
    ColorDialog1: TColorDialog;
    Panel1: TPanel;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButton4Click(Sender: TObject);
    procedure Image2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Privat  e 錾 }
    FMemStream      : TBytesStream;
    FGPBitmap       : TGPBitmap;
    FBackTBitmap    : TBitmap;
    FDispImgWidth   : Integer;
    FDispImgHeight  : Integer;
    FGPUseColor     : TGPColor;
    FOperationNo    : Cardinal;
    FDrawLineWidth  : Single;
    procedure DisplayImageToTImage;
    procedure DrawUseColorToTImage(AColor: TGPColor);
    procedure DrawFreeLine(ATImage: TImage; AGPBitmap: TGPBitmap; StartX,
      StartY, EndX, EndY: Integer; ASize: Single; AColor: TGPColor);
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

const
  OPERATION_NONE = $00;
  OPERATION_PAINT_DRAGDRAW       = $400;
  OPERATION_PAINT_DRAGDRAW_ERASE = $500;
var
  Flag_Continuance : Boolean = False;
  Flag_DragDrawing : Boolean = False;
  FStartPosX : Integer;
  FStartPosY : Integer;
  FPrevPosX  : Integer;
  FPrevPosY  : Integer;


//=============================================================================
//  tH[̏
//
//  TToolBar̊eTToolButtoñvpeB̒lȉɂĂ
//  (ToolButton4)
//  ̐ݒTToolButton.DownvpeB̒lgp\ɂȂ
//  TToolButton.Grouped := True:;
//  TToolButton.Style := tbsCheck;
//
//  ToolBar1.ParentDoubleBuffered := False
//  Form1.DoubleBuffered := True;
//
//  ToolBar1TPanel̏ɔzuĂ
//  Form1.DoubleBuffered := True;ɂƕ`悪邽
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
var
  LBackGroundFile : string;
begin
  Image1.Transparent := False;
  Image2.Transparent := False;

  //wiɕ`悷iq̎s͗l̃rbg}bv摜̐ݒ
  //ߏԂmF邽߂Ɏ{p
  FBackTBitmap := TBitmap.Create;
  LBackGroundFile := ExpandFileName('.\backTexture_01.bmp');
  if FileExists(LBackGroundFile) then begin
    FBackTBitmap.LoadFromFile(LBackGroundFile);
  end else begin
    FBackTBitmap := nil;
  end;

  //Xg[ɉ摜t@Cǂݍ
  FMemStream := TBytesStream.Create;
  FMemStream.LoadFromFile('502.png');

  //Xg[TGPBitmap쐬
  FGPBitmap := TGPBitmap.Create(TStreamAdapter.Create(FMemStream, soReference));

  //TCYw肵ĉ摜`
  FDispImgWidth  := 250;
  FDispImgHeight := Trunc(FDispImgWidth * FGPBitmap.GetHeight / FGPBitmap.GetWidth);
  DisplayImageToTImage;

  //gpF̏l
  FGPUseColor := ColorRefToARGB(clBlack);
  DrawUseColorToTImage(FGPUseColor);

  //Ƃ̎
  //TToolButton.DownvpeB̒lłǂ̃{^ꂽԂm邱Ƃł邪
  //ł͍Ɠe萔lŔ肷邱Ƃɂ
  FOperationNo := OPERATION_NONE;

  //`悷鎩Ȓ
  FDrawLineWidth := 10.0;
end;

//=============================================================================
//  tH[j̏
//=============================================================================
procedure TForm1.FormDestroy(Sender: TObject);
begin
  if Assigned(FGPBitmap)  then FreeAndNil(FGPBitmap);
  if Assigned(FMemStream) then FreeAndNil(FMemStream);
  if Assigned(FBackTBitmap) then FreeAndNil(FBackTBitmap);
end;

//=============================================================================
//  ToolButton1OnClickCxg
//  TToolButtonƂ̋LCxg
//  (ToolButton4)
//  e̐ݒ
//=============================================================================
procedure TForm1.ToolButton1Click(Sender: TObject);
begin
  if Sender = ToolButton1 then begin
    FOperationNo := OPERATION_NONE;
  end else
  if Sender = ToolButton2 then begin
    FOperationNo := OPERATION_PAINT_DRAGDRAW;
  end else
  if Sender = ToolButton3 then begin
    FOperationNo := OPERATION_PAINT_DRAGDRAW_ERASE;
  end;
end;

//=============================================================================
//  ToolButton4OnClickCxg
//  摜Cǂݍ񂾎̏Ԃɖ߂
//=============================================================================
procedure TForm1.ToolButton4Click(Sender: TObject);
begin
  if not Assigned(FGPBitmap) then exit;

   FreeAndNil(FGPBitmap);
   FGPBitmap := TGPBitmap.Create(TStreamAdapter.Create(FMemStream, soReference));
   //`
   DisplayImageToTImage;
end;

//=============================================================================
//  Image1OnMouseDownCxg
//  NbNsNZƓF̃sNZύX
//=============================================================================
procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  LGPGraphics : TGPGraphics;
  LGPBitmap   : TGPBitmap;
  LPoint      : TPoint;
  LClipRect   : TRect;
begin
  if not Assigned(FGPBitmap) then exit;
  if Button <> mbLeft then exit;


  if (FOperationNo = OPERATION_PAINT_DRAGDRAW)
    or (FOperationNo = OPERATION_PAINT_DRAGDRAW_ERASE) then begin

    //݂̕`TCYƓTCYTGPBitmap쐬
    if (FGPBitmap.GetWidth <> FDispImgWidth)
      or (FGPBitmap.GetHeight <> FDispImgHeight) then begin

      LGPBitmap := TGPBitmap.Create(FDispImgWidth, FDispImgHeight);
      LGPGraphics := TGPGraphics.Create(LGPBitmap);
      try
        LGPGraphics.DrawImage(FGPBitmap,
                              MakeRect(0, 0, FDispImgWidth, FDispImgHeight),
                              0,
                              0,
                              FGPBitmap.GetWidth,
                              FGPBitmap.GetHeight,
                              UnitPixel);
         //FGPBitmapݕ\̃TCYɂȂ
         FGPBitmap := TGPBitmap(LGPBitmap.Clone);
      finally
        FreeAndNil(LGPBitmap);
      end;
    end;


    Flag_DragDrawing := True;

    //}EXJ[\`pRg[̊OɈړȂ悤ɃNbv
    LPoint    := TControl(Sender).ClientToScreen(Point(0, 0));
    LClipRect := Rect(LPoint.X, LPoint.Y,
                 LPoint.X + TControl(Sender).Width,
                 LPoint.Y + TControl(Sender).Height);
    ClipCursor(@LClipRect);

    //}EX_Eʒuƕ`[_̍Wێ
    FStartPosX := X;
    FStartPosY := Y;
    FPrevPosX  := X;
    FPrevPosY  := Y;
  end;
end;

//=============================================================================
//  Panel1OnMouseMoveCxg
//  `撆̏
//=============================================================================
procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  LGPColor : TGPColor;
begin
  if Flag_DragDrawing then begin
    if (FOperationNo = OPERATION_PAINT_DRAGDRAW)
      or (FOperationNo = OPERATION_PAINT_DRAGDRAW_ERASE) then begin

      if FOperationNo = OPERATION_PAINT_DRAGDRAW then begin
        LGPColor := FGPUseColor;
      end else begin
        LGPColor := 0;
      end;
      DrawFreeLine(Image1, FGPBitmap, FPrevPosX, FPrevPosY, X, Y,
                                      FDrawLineWidth, LGPColor);
      FPrevPosX := X;
      FPrevPosY := Y;
    end;
  end;
end;

//=============================================================================
//  Panel1OnMouseUpCxg
//  `I
//=============================================================================
procedure TForm1.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Flag_DragDrawing then begin
    Flag_DragDrawing := False;
    //}EẌړ̃Nbv
    ClipCursor(nil);
  end;
end;

//=============================================================================
//  Image3OnMouseDownCxg
//  FI_CAO\ăsNZ̐FύXɎgpFI
//  TColorDialog_CAOɂ̓At@l̐ݒ@\͂Ȃ
//
//  Imaae2̓sNZ̐FύXɎgpF\p̃Rg[
//=============================================================================
procedure TForm1.Image2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ColorDialog1.Color := ARGBToColorRef(FGPUseColor);
  if ColorDialog1.Execute then begin
    FGPUseColor := ColorRefToARGB(ColorDialog1.Color);
    DrawUseColorToTImage(FGPUseColor);
  end;
end;

//-----------------------------------------------------------------------------
//  TImageւ̕`̃R[h
//-----------------------------------------------------------------------------
procedure TForm1.DisplayImageToTImage;
var
  LGPGraphics : TGPGraphics;
begin
  Image1.Picture.Assign(nil);
  if (FDispImgWidth <> Image1.Width) or (FDispImgHeight <> Image1.Height) then begin
    Image1.Picture.Bitmap.SetSize(FDispImgWidth, FDispImgHeight);
  end;

  LGPGraphics := TGPGraphics.Create(Image1.Canvas.Handle);
  try
    //wi摜̎w肪Ε`
    if Assigned(FBackTBitmap) then begin
      Image1.Canvas.Brush.Bitmap := FBackTBitmap;
      Image1.Canvas.FillRect(Image1.ClientRect);
    end;

    LGPGraphics.DrawImage(FGPBitmap,
                          MakeRect(0, 0, FDispImgWidth, FDispImgHeight),
                          0,
                          0,
                          FGPBitmap.GetWidth,
                          FGPBitmap.GetHeight,
                          UnitPixel);
  finally
    FreeAndNil(LGPGraphics);
  end;
end;

//-----------------------------------------------------------------------------
//  gpF\ĂTImaeRg[ւ̕`p[`
//-----------------------------------------------------------------------------
procedure TForm1.DrawUseColorToTImage(AColor: TGPColor);
var
  LGPGraphic : TGPGraphics;
  LGPBrush   : TGPSolidBrush;
  LGPRect    : TGPRect;
begin
  Image2.Picture.Assign(nil);
  //TGPSolidBrush𐶐
  LGPBrush := TGPSolidBrush.Create(AColor);
  //`TImageɂTGPGraphics.Create
  LGPGraphic := TGPGraphics.Create(Image2.Canvas.Handle);
  try
    //`hׂ`
    LGPRect := MakeRect(0, 0, Image2.Width, Image2.Height);
    LGPGraphic.FillRectangle(LGPBrush, LGPRect);
  finally
    FreeAndNil(LGPGraphic);
    FreeAndNil(LGPBrush);
  end;
  Edit1.Text := '$' + IntToHex(AColor, 8);
end;

//-----------------------------------------------------------------------------
//  }EẌړɔ`悷̃[`
//  쑬xɑ肠
//  ړxƕ`悪ꍇ
//-----------------------------------------------------------------------------
procedure TForm1.DrawFreeLine(ATImage: TImage; AGPBitmap: TGPBitmap;
  StartX, StartY, EndX, EndY: Integer; ASize: Single; AColor: TGPColor);
var
  LGPGRraphic : TGPGraphics;
  LGPPen      : TGPPen;
  LGPBrush    : TGPSolidBrush;
  LLeft       : Single;
  LTop        : Single;
begin
  LGPPen      := TGPPen.Create(AColor, ASize);
  LGPBrush    := TGPSolidBrush.Create(AColor);
  LGPGRraphic := TGPGraphics.Create(AGPBitmap);
  try
    if AColor = 0 then begin
      LGPGRraphic.SetCompositingMode(CompositingModeSourceCopy);
    end;

    LLeft := StartX - ASize / 2.0;
    LTop  := StartY - ASize / 2.0;

    LGPGRraphic.FillRectangle(LGPBrush, LLeft, LTop, ASize, ASize);
    LGPGRraphic.DrawLine(LGPPen, StartX, StartY, EndX, EndY);
  finally
    FreeAndNil(LGPGRraphic);
    FreeAndNil(LGPPen);
    FreeAndNil(LGPBrush);
  end;

  DisplayImageToTImage;
end;

end.
