//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  GDI+ ֌WTv
//  }EXŎn_ƏI_w肵Ē`
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2017N0715 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, GDIPAPI, GDIPOBJ, GDIPUTIL, ComCtrls, ExtDlgs,
  ImgList, ToolWin;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    ImageList1: TImageList;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    Edit1: TEdit;
    ColorDialog1: TColorDialog;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButton4Click(Sender: TObject);
    procedure Image3MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Privat  e 錾 }
    FPixelRectSize  : Cardinal;
    FMaxImgPixels   : Integer;
    FPixelGridColor : TColor;
    FGPBitmap       : TGPBitmap;
    FBackTBitmap    : TBitmap;
    FGPUseColor     : TGPColor;
    FOperationNo    : Cardinal;
    procedure DisplayImageAndGridLine(NeedInvalidate: Boolean);
    procedure DrawUseColorToTImage(AColor: TGPColor);
  public
    { Public 錾 }
    procedure DrawPixelColorToTImage(SrcGPBitmap: TGPBitmap; DrawTimage: TImage;
      PixelRectSize: Integer; MaxImgPixels: Integer; GridLineColor: TColor;
      BackImage: TBitmap = nil; ShowGridLine: Boolean = True;
      BackGround: Boolean = True);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

const
  OPERATION_NONE = $00;
  OPERATION_DRAWLINE_SOLID = $30;
  OPERATION_DRAWLINE_LINER = $40;
var
  Flag_Continuance : Boolean = False;
  Flag_DragDrawing : Boolean = False;
  FStartPosX : Integer;
  FStartPosY : Integer;
  FPrevPosX  : Integer;
  FPrevPosY  : Integer;

//=============================================================================
//  tH[̏
//
//  TToolBar̊eTToolButtoñvpeB̒lȉɂĂ
//  (ToolButton)
//  ̐ݒTToolButton.DownvpeB̒lgp\ɂȂ
//  TToolButton.Grouped := True:;
//  TToolButton.Style := tbsCheck;
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
var
  LBackGroundFile : string;
begin
  //Obh̐FƃsNZ̕`TCY
  FPixelGridColor := clGray;
  FPixelRectSize  := 9;
  FMaxImgPixels   := 128;

  Image1.Transparent := False;
  Image2.Transparent := False;
  Image3.Transparent := False;

  //wiɕ`悷iq̎s͗l̃rbg}bv摜̐ݒ
  //ߏԂmF邽߂Ɏ{p
  FBackTBitmap := TBitmap.Create;
  LBackGroundFile := ExpandFileName('.\backTexture_02.bmp');
  if FileExists(LBackGroundFile) then begin
    FBackTBitmap.LoadFromFile(LBackGroundFile);
  end else begin
    FBackTBitmap := nil;
  end;

  //摜̂ȂTGPBitmap쐬
  FGPBitmap := TGPBitmap.Create(32, 32);

  //gpF̏l
  FGPUseColor := ColorRefToARGB(clBlack);
  DrawUseColorToTImage(FGPUseColor);

  //摜ƃsNZ̃Obh\
  DisplayImageAndGridLine(True);

  //Ƃ̎
  FOperationNo := OPERATION_NONE;
end;

//=============================================================================
//  tH[j̏
//=============================================================================
procedure TForm1.FormDestroy(Sender: TObject);
begin
  if Assigned(FGPBitmap)  then FreeAndNil(FGPBitmap);
  if Assigned(FBackTBitmap) then FreeAndNil(FBackTBitmap);
end;

//=============================================================================
//  ToolButton1OnClickCxg
//  TToolButtonƂ̋LCxg
//  (ToolButton)
//  e̐ݒ
//=============================================================================
procedure TForm1.ToolButton1Click(Sender: TObject);
begin
  if Sender = ToolButton1 then begin
    FOperationNo := OPERATION_NONE;
  end else
  if Sender = ToolButton2 then begin
    FOperationNo := OPERATION_DRAWLINE_SOLID;
  end else
  if Sender = ToolButton3 then begin
    FOperationNo := OPERATION_DRAWLINE_LINER;
  end;
end;

//=============================================================================
//  ToolButton4OnClickCxg
//  `̃NA
//=============================================================================
procedure TForm1.ToolButton4Click(Sender: TObject);
var
  LGPGraphics : TGPGraphics;
begin
  if not Assigned(FGPBitmap) then exit;

  LGPGraphics := TGPGraphics.Create(FGPBitmap);
  try
    LGPGraphics.Clear(0);
  finally
    FreeAndNil(LGPGraphics);
  end;
  DisplayImageAndGridLine(True);
end;

//=============================================================================
//  Image1OnMouseDownCxg
//  o[oh̕`Jn
//
//  Imaae1͉摜g\sNZ̐F\p
//=============================================================================
procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  LPoint    : TPoint;
  LClipRect : TRect;
begin
  if not Assigned(FGPBitmap) then exit;
  if Button <> mbLeft then exit;

  if (FOperationNo = OPERATION_DRAWLINE_SOLID)
    or (FOperationNo = OPERATION_DRAWLINE_LINER) then begin

    Flag_DragDrawing := True;

    //}EXJ[\`pRg[̊OɈړȂ悤ɃNbv
    LPoint    := TControl(Sender).ClientToScreen(Point(0, 0));
    LClipRect := Rect(LPoint.X, LPoint.Y,
                 LPoint.X + TControl(Sender).Width,
                 LPoint.Y + TControl(Sender).Height);
    ClipCursor(@LClipRect);

    //o[oh`悷̐ݒ
    //ModepmNotXorɂďd˕`悵ł悤ɂ
    Image1.Canvas.Pen.Color := clBlack;
    Image1.Canvas.Pen.Width := 2;
    Image1.Canvas.Pen.Style := psSolid;
    Image1.Canvas.Pen.Mode  := pmNotXor;

    //}EX_Eʒuƕ`[_̍Wێ
    FStartPosX := X;
    FStartPosY := Y;
    FPrevPosX  := X;
    FPrevPosY  := Y;

    //`Jn_Ƀyړ
    Image1.Canvas.MoveTo(FStartPosX, FStartPosY);
  end else
  if FOperationNo = OPERATION_DRAWLINE_LINER then begin
  end;
end;

//=============================================================================
//  Image1OnMouseMoveCxg
//  }EXhbN̏(o[oh`撆̏)
//=============================================================================
procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if Flag_DragDrawing then begin
    //`悵d˕`悵ď
    Image1.Canvas.MoveTo(FStartPosX, FStartPosY);
    Image1.Canvas.LineTo(FPrevPosX, FPrevPosY);

    //VKɐ`
    Image1.Canvas.MoveTo(FStartPosX, FStartPosY);
    Image1.Canvas.LineTo(X, Y);

    //`[_݂̌̍Wlێ
    FPrevPosX := X;
    FPrevPosY := Y;
  end;
end;

//=============================================================================
//  Image1OnMouseUpCxg
//  }EXhbNI(o[oh`I)
//  ۂɒ`悷
//=============================================================================
procedure TForm1.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  LPenWidth     : Single;
  LGPGraphics   : TGPGraphics;
  LGPPen        : TGPPen;
  LGPLinerBrush : TGPLinearGradientBrush;
begin
  if Flag_DragDrawing then begin
    Flag_DragDrawing := False;

    //Ō̕`d˕`悵ď
    Image1.Canvas.MoveTo(FStartPosX, FStartPosY);
    Image1.Canvas.LineTo(X, Y);
    //}EẌړ̃Nbv
    ClipCursor(nil);

    //ۂ̉摜̍Wlɕϊ
    FStartPosX := FStartPosX div FPixelRectSize;
    FStartPosY := FStartPosY div FPixelRectSize;
    FPrevPosX  := X div FPixelRectSize;
    FPrevPosY  := Y div FPixelRectSize;

    //-------------------------------------------------------------------------
    //  ܂łŃo[oh͏I
    //  ȉۂ̒̕`
    //  `TGPBitmapɑ΂čsĎꂻTGPBitmapTImageCanvasɕ`
    //-------------------------------------------------------------------------

    if FOperationNo = OPERATION_DRAWLINE_SOLID then begin
      LPenWidth := 1.0;
      LGPGraphics := TGPGraphics.Create(FGPBitmap);
      LGPPen      := TGPPen.Create(FGPUseColor, LPenWidth);
      try
        //A`GCAX̐ݒĕ`
        LGPGraphics.SetSmoothingMode(SmoothingModeAntiAlias);
        LGPGraphics.DrawLine(LGPPen, FStartPosX, FStartPosY, FPrevPosX, FPrevPosY);
      finally
        FreeAndNil(LGPGraphics);
        FreeAndNil(LGPPen);
      end;
    end else
    if FOperationNo = OPERATION_DRAWLINE_LINER then begin
      LPenWidth := 3.5;
      LGPLinerBrush := TGPLinearGradientBrush.Create(MakeRect(
                                                0,
                                                0,
                                                FGPBitmap.GetWidth,
                                                FGPBitmap.GetHeight),
                                                FGPUseColor,
                                                aclWhite,
                                                LinearGradientModeForwardDiagonal);
      LGPGraphics := TGPGraphics.Create(FGPBitmap);
      LGPPen      := TGPPen.Create(LGPLinerBrush, LPenWidth);
      try
        //[_ƃA`GCAX̐ݒĕ`
        LGPPen.SetStartCap(LineCapRound);
        LGPPen.SetEndCap(LineCapRound);
        LGPGraphics.SetSmoothingMode(SmoothingModeAntiAlias);
        LGPGraphics.DrawLine(LGPPen, FStartPosX, FStartPosY, FPrevPosX, FPrevPosY);
      finally
        FreeAndNil(LGPGraphics);
        FreeAndNil(LGPPen);
        FreeAndNil(LGPLinerBrush);
      end;
    end;
  end;

  //摜ƃsNZ̃Obh\
  DisplayImageAndGridLine(True);
end;

//=============================================================================
//  Image3OnMouseDownCxg
//  FI_CAO\ăsNZ̐FύXFI
//  TColorDialog_CAOɂ̓At@l̐ݒ@\͂Ȃ
//
//  Imaae3̓sNZ̐FύXɎgpF\p̃Rg[
//=============================================================================
procedure TForm1.Image3MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ColorDialog1.Color := ARGBToColorRef(FGPUseColor);
  if ColorDialog1.Execute then begin
    FGPUseColor := ColorRefToARGB(ColorDialog1.Color);
    DrawUseColorToTImage(FGPUseColor);
  end;
end;

//-----------------------------------------------------------------------------
//  TImageւ̕`̃R[h
//  TCYƊg\pObh\
//-----------------------------------------------------------------------------
procedure TForm1.DisplayImageAndGridLine(NeedInvalidate: Boolean);
var
  LGPGraphics : TGPGraphics;
begin
  //TGPBitmapTImageɎTCYŕ`
  if NeedInvalidate then begin
    Image2.Picture.Assign(nil);
    LGPGraphics := TGPGraphics.Create(Image2.Canvas.Handle);
    LGPGraphics.DrawImage(FGPBitmap, 0, 0);
    LGPGraphics.Free;
  end;

  //sNZ̃Obh\
  DrawPixelColorToTImage(FGPBitmap, Image1, FPixelRectSize, FMaxImgPixels,
                         FPixelGridColor, FBackTBitmap);
end;

//-----------------------------------------------------------------------------
//  gpF\ĂTImaeRg[ւ̕`p[`
//-----------------------------------------------------------------------------
procedure TForm1.DrawUseColorToTImage(AColor: TGPColor);
var
  LGPGraphic : TGPGraphics;
  LGPBrush   : TGPSolidBrush;
  LGPRect    : TGPRect;
begin
  Image3.Picture.Assign(nil);
  //TGPSolidBrush𐶐
  LGPBrush := TGPSolidBrush.Create(AColor);
  //`TImageɂTGPGraphics.Create
  LGPGraphic := TGPGraphics.Create(Image3.Canvas.Handle);
  try
    LGPRect := MakeRect(0, 0, Image3.Width, Image3.Height);
    LGPGraphic.FillRectangle(LGPBrush, LGPRect);
  finally
    FreeAndNil(LGPGraphic);
    FreeAndNil(LGPBrush);
  end;
  Edit1.Text := '$' + IntToHex(AColor, 8);
end;

//-----------------------------------------------------------------------------
//  TGPBitmap̊esNZ̐FObh\
//-----------------------------------------------------------------------------
procedure TForm1.DrawPixelColorToTImage(SrcGPBitmap: TGPBitmap;
  DrawTimage: TImage; PixelRectSize: Integer;  MaxImgPixels: Integer;
  GridLineColor: TColor; BackImage: TBitmap = nil; ShowGridLine: Boolean = True;
  BackGround: Boolean = True);
type
  TRGBQArray = array [0..4095] of RGBQUAD;
  PRGBQArray = ^TRGBQArray;
var
  LSrcImgWidth  : Integer;
  LSrcImgHeight : Integer;
  LImgWidth     : Integer;
  LImgHeight    : Integer;
  LBmpData      : TBitmapData;
  LScanLine     : PByte;
  LpRGBQuad     : PRGBQuad;
  LDataStride   : Integer;
  LAValue       : Byte;
  LRValue       : Byte;
  LGValue       : Byte;
  LBValue       : Byte;
  LXPos         : Integer;
  LYPos         : Integer;
  LImgBitmap    : TBitmap;
  LDstScanArray : PRGBQArray;
  LiiX          : Integer;
  LiiY          : Integer;
  LGridRValue   : Byte;
  LGridGValue   : Byte;
  LGridBValue   : Byte;
  LBitmap       : TBitmap;
begin
  DrawTimage.Picture.Assign(nil);

  //摜̃TCY擾
  LSrcImgWidth  := SrcGPBitmap.GetWidth;
  LSrcImgHeight := SrcGPBitmap.GetHeight;
  if LSrcImgWidth > MaxImgPixels  then LSrcImgWidth  := MaxImgPixels;
  if LSrcImgHeight > MaxImgPixels then LSrcImgHeight := MaxImgPixels;

  //Obh\̕`TCY
  LImgWidth  := LSrcImgWidth * PixelRectSize + 1;
  LImgHeight := LSrcImgHeight * PixelRectSize + 1;

  //wi摜̎w肪Ε`
  if (Assigned(BackImage)) and BackGround then begin
    DrawTimage.Canvas.Brush.Bitmap := BackImage;
    DrawTimage.Canvas.FillRect(DrawTimage.ClientRect);
  end;


  //TGPBitmap̃rbg}bvf[^擾
  if SrcGPBitmap.LockBits(MakeRect(0, 0, LSrcImgWidth, LSrcImgHeight),
             ImageLockModeRead, PixelFormat32bppARGB, LBmpData) <> Ok then exit;

  //sNZƃObh`悷TBitmap쐬
  //ɕ`悵TImageCanvasɕ`悷
  LImgBitmap := TBitmap.Create;
  try
    LImgBitmap.SetSize(LImgWidth, LImgHeight);
    LImgBitmap.PixelFormat := pf32bit;
    //AlphaFormat := afIgnoredƂĂ
    //afIgnoredɂȂĔ̃sNZɕ`łȂ
    //TImage.Canvasɕ`悷鎞afDefinedɂ
    LImgBitmap.AlphaFormat := afIgnored;

    LScanLine   := LBmpData.Scan0;
    LDataStride := LBmpData.Stride;

    //Obh̐FRGBl擾Ă
    LGridRValue := GetRValue(GridLineColor);
    LGridGValue := GetGValue(GridLineColor);
    LGridBValue := GetBValue(GridLineColor);

    for LYPos := 0 to LSrcImgHeight - 1 do begin
      LpRGBQuad := PRGBQuad(LScanLine);
      LImgBitmap.Canvas.Lock;

      for LXPos := 0 to LSrcImgWidth - 1 do begin

        LAValue := LpRGBQuad^.rgbReserved;
        LRValue := LpRGBQuad^.rgbRed;
        LGValue := LpRGBQuad^.rgbGreen;
        LBValue := LpRGBQuad^.rgbBlue;

        for LiiY := 0 to PixelRectSize do begin
          LDstScanArray  := LImgBitmap.ScanLine[LYPos * PixelRectSize + LiiY];

          //̕Obhւ̕`
          for LiiX := 0 to PixelRectSize do begin
            //Obh`悷Wl̎
            if (ShowGridLine) and ((LiiY = 0) or (LiiX = 0) or
              (LiiY = PixelRectSize) or (LiiX = PixelRectSize)) then begin
              LDstScanArray[LXPos * PixelRectSize + LiiX].rgbReserved := $FF;
              LDstScanArray[LXPos * PixelRectSize + LiiX].rgbRed      := LGridRValue;
              LDstScanArray[LXPos * PixelRectSize + LiiX].rgbGreen    := LGridGValue;
              LDstScanArray[LXPos * PixelRectSize + LiiX].rgbBlue     := LGridBValue;
            end else begin
              LDstScanArray[LXPos * PixelRectSize + LiiX].rgbReserved := LAValue;
              LDstScanArray[LXPos * PixelRectSize + LiiX].rgbRed      := LRValue;
              LDstScanArray[LXPos * PixelRectSize + LiiX].rgbGreen    := LGValue;
              LDstScanArray[LXPos * PixelRectSize + LiiX].rgbBlue     := LBValue;
            end;
          end;
        end;

        Inc(LpRGBQuad);
      end;
      Inc(LScanLine, LDataStride);
    end;

    //쐬TBitmapTImageCanvasɕ`
    //AlphaFormat := afDefinedɂĔ摜̃sNZŕ\
    DrawTimage.Picture.Bitmap.SetSize(LImgWidth, LImgHeight);
    LImgBitmap.AlphaFormat := afDefined;
    DrawTimage.Canvas.Draw(0, 0, LImgBitmap);
  finally
    SrcGPBitmap.UnlockBits(LBmpData);
    LImgBitmap.Canvas.Unlock;

    FreeAndNil(LImgBitmap);
  end;
end;

end.
