//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  GDI+ ֌WTv
//  摜̏㉺Eւ̃Vtg - 摜̕`ʒu̒
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2017N0715 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, GDIPAPI, GDIPOBJ, GDIPUTIL, ComCtrls, ExtDlgs,
  ImgList, ToolWin;

type
  TForm1 = class(TForm)
    Image2: TImage;
    Image1: TImage;
    OpenPictureDialog1: TOpenPictureDialog;
    SavePictureDialog1: TSavePictureDialog;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton7: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ImageList1: TImageList;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    CheckBox1: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure ToolButton8Click(Sender: TObject);
    procedure ToolButton9Click(Sender: TObject);
  private
    { Privat  e 錾 }
    FLoadInitDir    : string;
    FSaveInitDir    : string;
    FImageFilePath  : string;
    FTempFilePath   : string;
    FSaveFilePath   : string;
    FPixelRectSize  : Cardinal;
    FMaxImgPixels   : Integer;
    FPixelGridColor : TColor;
    FMemStream      : TBytesStream;
    FGPOriginBitmap : TGPBitmap;
    FGPBitmap       : TGPBitmap;
    FBackTBitmap    : TBitmap;
    FUPMoveCnt      : Integer;
    FLeftMoveCnt    : Integer;
    procedure DisplayImageAndGridLine(NeedInvalidate: Boolean);
    function SetAlphaValueFromTBitmap(DstGPBitmap: TGPBitmap;
      SrcBitmap: TBitmap): Boolean;
    function ChangeColor(TarGPBitmap: TGPBitmap; OldColor, NewColor: TGPColor):
      Boolean;
  public
    { Public 錾 }
    procedure DrawPixelColorToTImage(SrcGPBitmap: TGPBitmap; DrawTimage: TImage;
      PixelRectSize: Integer; MaxImgPixels: Integer; GridLineColor: TColor;
      BackImage: TBitmap = nil; ShowGridLine: Boolean = True;
      BackGround: Boolean = True);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

//=============================================================================
//  tH[̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
var
  LBackGroundFile : string;
begin
  //t@C̓ǂݏoƕۑ̏fBNg
  FLoadInitDir := ExpandFileName('.\');
  FSaveInitDir := ExpandFileName('.\');

  //Obh̐FƃsNZ̕`TCY
  FPixelGridColor := clGray;
  FPixelRectSize  := 9;
  FMaxImgPixels   := 128;

  //ǂݍ񂾉摜kTCY
  CheckBox1.Checked := True;

  Image1.Transparent := False;
  Image2.Transparent := False;

  //wiɕ`悷iq̎s͗l̃rbg}bv摜̐ݒ
  //ߏԂmF邽߂Ɏ{p
  FBackTBitmap := TBitmap.Create;
  LBackGroundFile := ExpandFileName('.\backTexture_02.bmp');
  if FileExists(LBackGroundFile) then begin
    FBackTBitmap.LoadFromFile(LBackGroundFile);
  end else begin
    FBackTBitmap := nil;
  end;
end;

//=============================================================================
//  tH[j̏
//=============================================================================
procedure TForm1.FormDestroy(Sender: TObject);
begin
  if Assigned(FGPOriginBitmap) then FreeAndNil(FGPOriginBitmap);
  if Assigned(FGPBitmap)  then FreeAndNil(FGPBitmap);
  if Assigned(FMemStream) then FreeAndNil(FMemStream);
  if Assigned(FBackTBitmap) then FreeAndNil(FBackTBitmap);
end;

//=============================================================================
//  摜t@C̓ǂݍ
//  PNG`ƃrbg}bv̂
//  ǂݍ݌C̃sNZ̐F𓧉ߐFƂēFɕϊ
//=============================================================================
procedure TForm1.ToolButton1Click(Sender: TObject);
var
  LGPGraphic  : TGPGraphics;
  LOriginSize : Integer;
  LBitmap     : TBitmap;
  LGPColor    : TGPColor;
begin
  OpenPictureDialog1.Filter := 'PNG 摜|*.png'
                             + '|rbg}bv摜|*.bmp';
  OpenPictureDialog1.InitialDir := FLoadInitDir;
  if not OpenPictureDialog1.Execute then exit;

  FImageFilePath := OpenPictureDialog1.FileName;
  FLoadInitDir   :=  ExtractFileDir(FTempFilePath);


  if Assigned(FGPOriginBitmap) then FreeAndNil(FGPOriginBitmap);
  if Assigned(FGPBitmap)  then FreeAndNil(FGPBitmap);
  if Assigned(FMemStream) then FreeAndNil(FMemStream);

  //Xg[ɉ摜t@Cǂݍ
  FMemStream := TBytesStream.Create;
  FMemStream.LoadFromFile(FImageFilePath);

  //Xg[TGPBitmap쐬
  //1̂쐬Ă
  FGPBitmap := TGPBitmap.Create(TStreamAdapter.Create(FMemStream, soReference));

  if UpperCase(ExtractFileExt(FImageFilePath)) = '.BMP' then begin
    LBitmap := TBitmap.Create;
    try
      FMemStream.Position := 0;
      LBitmap.LoadFromStream(FMemStream);
      if LBitmap.PixelFormat = pf32bit then begin
        SetAlphaValueFromTBitmap(FGPBitmap, LBitmap);
      end;
    finally
      FreeAndNil(LBitmap);
     end;
  end else
  if UpperCase(ExtractFileExt(FImageFilePath)) = '.PNG' then begin
    //PNG`̉摜At@`l̏Kvȏꍇ
    //ł̓At@`l̏KvȂPNG摜łƉ
  end else begin
    exit;
  end;

  //摜̍̐F𓧉ߐFɂ鏈
  FGPBitmap.GetPixel(0, FGPBitmap.GetHeight - 1, LGPColor);
  ChangeColor(FGPBitmap, LGPColor, 0);

  FGPOriginBitmap := TGPBitmap(FGPBitmap.Clone);

  if CheckBox1.Checked then begin
    //1TGPBitmapɓǂݍ񂾉摜24x24ɃTCYĕ`
    //̃TCYTGPBitmapIWỉ摜Ƃ
    LGPGraphic := TGPGraphics.Create(FGPOriginBitmap);
    try
      LOriginSize := 24;
      LGPGraphic.Clear(0);
      LGPGraphic.DrawImage(FGPBitmap,
                           MakeRect(0, 0, LOriginSize, LOriginSize),
                           0,
                           0,
                           FGPBitmap.GetWidth,
                           FGPBitmap.GetHeight,
                           UnitPixel);
      FGPBitmap := TGPBitmap(FGPOriginBitmap.Clone);
    finally
      FreeAndNil(LGPGraphic);
    end;
  end;

  //摜ƃsNZ̃Obh\
  DisplayImageAndGridLine(True);

  //㉺ËړʂZbg
  FUPMoveCnt   := 0;
  FLeftMoveCnt := 0;
end;

//=============================================================================
//  ҏWʂۑ
//  PNG`ƃrbg}bv̂
//  rbg}bv32rbg̃At@`ltƂȂ
//=============================================================================
procedure TForm1.ToolButton2Click(Sender: TObject);
var
  LImgGUID : TGUID;
  LBitmap  : TBitmap;
  LhBitmap : HBITMAP;
begin
  if not Assigned(FGPBitmap) then exit;

  SavePictureDialog1.DefaultExt  := '.png';
  SavePictureDialog1.Filter := 'PNG 摜|*.png'
                             + '|rbg}bv摜|*.bmp';

  SavePictureDialog1.InitialDir := FSaveInitDir;
  SavePictureDialog1.FileName := ExtractFileName(FImageFilePath);
  if not SavePictureDialog1.Execute then exit;


  FSaveFilePath := SavePictureDialog1.FileName;
  FSaveInitDir  := ExtractFileDir(FSaveFilePath);

  if SavePictureDialog1.FilterIndex = 1 then begin
    //PNG`摜Ƃĕۑ
    if GetEncoderClsid('image/png', LImgGUID) >= 0 then begin
      FSaveFilePath := ChangeFileExt(FSaveFilePath, '.png');
      FGPBitmap.Save(FSaveFilePath, LImgGUID);
    end;
  end else
  if SavePictureDialog1.FilterIndex = 2 then begin
    //rbg}bv摜Ƃĕۑ
    LBitmap := TBitmap.Create;
    try
      FGPBitmap.GetHBITMAP(0, LhBitmap);
      LBitmap.Handle := LhBitmap;

      FSaveFilePath := ChangeFileExt(FSaveFilePath, '.bmp');
      LBitmap.SaveToFile(FSaveFilePath);
    finally
      FreeAndNil(LBitmap);
    end;
  end;
end;

//=============================================================================
//  摜̒ǉ`̗
//  Kvɉĕ`ʒuTCYw肵ĕ`悷
//=============================================================================
procedure TForm1.ToolButton9Click(Sender: TObject);
var
  LFilePath  : string;
  LStream    : TBytesStream;
  LGPbitmap  : TGPBitmap;
  LGPGraphic : TGPGraphics;
  LBitmap    : TBitmap;
  LGPColor   : TGPColor;
begin
  if not Assigned(FGPBitmap) then exit;
  if not OpenPictureDialog1.Execute then exit;


  LFilePath := OpenPictureDialog1.FileName;
  //Xg[ɉ摜t@Cǂݍ
  LStream := TBytesStream.Create;
  LStream.LoadFromFile(LFilePath);

  //Xg[TGPBitmap쐬
  LGPBitmap  := TGPBitmap.Create(TStreamAdapter.Create(LStream, soReference));
  LGPGraphic := TGPGraphics.Create(FGPBitmap);

  try
    if UpperCase(ExtractFileExt(LFilePath)) = '.BMP' then begin
      LBitmap := TBitmap.Create;
      try
        LStream.Position := 0;
        LBitmap.LoadFromStream(LStream);
        if LBitmap.PixelFormat = pf32bit then begin
          SetAlphaValueFromTBitmap(LGPbitmap, LBitmap);
        end;
      finally
        FreeAndNil(LBitmap);
       end;
    end else
    if UpperCase(ExtractFileExt(FImageFilePath)) = '.PNG' then begin
      //PNG`̉摜At@`l̏Kvȏꍇ
      //ł̓At@`l̏KvȂPNG摜łƉ
    end else begin
      exit;
    end;

    //摜̍̐F𓧉ߐFɂ鏈
    LGPbitmap.GetPixel(0, LGPbitmap.GetHeight - 1, LGPColor);
    ChangeColor(LGPbitmap, LGPColor, 0);

    //`
    LGPGraphic.DrawImage(LGPBitmap, 0, 0);
    DisplayImageAndGridLine(True);
  finally
    FreeAndNil(LStream);
    FreeAndNil(LGPbitmap);
    FreeAndNil(LGPGraphic);
  end;
end;

//=============================================================================
//  ToolButton3OnClickCxg
//  ToolButton3,ToolButton4,ToolButton5,ToolButton6L̃Cxg
//
//  1sNZړ(㉺E1sNZP)
//=============================================================================
procedure TForm1.ToolButton3Click(Sender: TObject);
var
  LGPGraphic : TGPGraphics;
  LWidth     : Integer;
  LHeight    : Integer;
begin
  if not Assigned(FGPBitmap) then exit;

  LGPGraphic := TGPGraphics.Create(FGPBitmap);
  try
    //\̉摜̓NA
    LGPGraphic.Clear(0);

    LWidth  := FGPOriginBitmap.GetWidth;
    LHeight := FGPOriginBitmap.GetHeight;

    if Sender = ToolButton3 then  begin
      if FUPMoveCnt >= (LHeight - 3) then exit;
      inc(FUPMoveCnt);
    end else
    if Sender = ToolButton4 then  begin
      if FUPMoveCnt <= -(LHeight - 3) then exit;
      Dec(FUPMoveCnt);
    end else
    if Sender = ToolButton5 then begin
      if FLeftMoveCnt >= (LWidth - 3) then exit;
      inc(FLeftMoveCnt);
    end else
    if Sender = ToolButton6 then begin
      if FLeftMoveCnt <= -(LWidth - 3) then exit;
      Dec(FLeftMoveCnt);
    end;

    //TGPBitmapwsNZړTGPBitmap쐬
    LGPGraphic.DrawImage(FGPOriginBitmap,
                         MakeRect(0, 0, LWidth, LHeight),
                         FLeftMoveCnt,
                         FUPMoveCnt,
                         LWidth,
                         LHeight,
                         UnitPixel);

    //쐬TGPBitmap`
    DisplayImageAndGridLine(True);
  finally
    FreeAndNil(LGPGraphic);
  end;
end;

//=============================================================================
//  ǂݍŃTCỶ摜ɖ߂
//=============================================================================
procedure TForm1.ToolButton8Click(Sender: TObject);
begin
  if not Assigned(FGPBitmap) then exit;

  //㉺ËړʂZbg
  FUPMoveCnt   := 0;
  FLeftMoveCnt := 0;

  FGPBitmap := TGPBitmap(FGPOriginBitmap.Clone);
  DisplayImageAndGridLine(True);
end;

//-----------------------------------------------------------------------------
//  TImageւ̕`̃R[h
//  TCYƊg\ăObh̕`
//-----------------------------------------------------------------------------
procedure TForm1.DisplayImageAndGridLine(NeedInvalidate: Boolean);
var
  LGPGraphics : TGPGraphics;
begin
  //TGPBitmapTImageɎTCYŕ`
  if NeedInvalidate then begin
    Image2.Picture.Assign(nil);
    LGPGraphics := TGPGraphics.Create(Image2.Canvas.Handle);
    LGPGraphics.DrawImage(FGPBitmap, 0, 0);
    LGPGraphics.Free;
  end;

  //sNZ̃Obh\
  DrawPixelColorToTImage(FGPBitmap, Image1, FPixelRectSize, FMaxImgPixels,
                         FPixelGridColor, FBackTBitmap);
end;

//-----------------------------------------------------------------------------
//  TGPBitmap̊esNZ̐FObh\
//-----------------------------------------------------------------------------
procedure TForm1.DrawPixelColorToTImage(SrcGPBitmap: TGPBitmap;
  DrawTimage: TImage; PixelRectSize: Integer;  MaxImgPixels: Integer;
  GridLineColor: TColor; BackImage: TBitmap = nil; ShowGridLine: Boolean = True;
  BackGround: Boolean = True);
type
  TRGBQArray = array [0..4095] of RGBQUAD;
  PRGBQArray = ^TRGBQArray;
var
  LSrcImgWidth  : Integer;
  LSrcImgHeight : Integer;
  LImgWidth     : Integer;
  LImgHeight    : Integer;
  LBmpData      : TBitmapData;
  LScanLine     : PByte;
  LpRGBQuad     : PRGBQuad;
  LDataStride   : Integer;
  LAValue       : Byte;
  LRValue       : Byte;
  LGValue       : Byte;
  LBValue       : Byte;
  LXPos         : Integer;
  LYPos         : Integer;
  LImgBitmap    : TBitmap;
  LDstScanArray : PRGBQArray;
  LiiX          : Integer;
  LiiY          : Integer;
  LGridRValue   : Byte;
  LGridGValue   : Byte;
  LGridBValue   : Byte;
  LBitmap       : TBitmap;
begin
  DrawTimage.Picture.Assign(nil);

  //摜̃TCY擾
  LSrcImgWidth  := SrcGPBitmap.GetWidth;
  LSrcImgHeight := SrcGPBitmap.GetHeight;
  if LSrcImgWidth > MaxImgPixels  then LSrcImgWidth  := MaxImgPixels;
  if LSrcImgHeight > MaxImgPixels then LSrcImgHeight := MaxImgPixels;

  //Obh\̕`TCY
  LImgWidth  := LSrcImgWidth * PixelRectSize + 1;
  LImgHeight := LSrcImgHeight * PixelRectSize + 1;

  //wi摜̎w肪Ε`
  if (Assigned(BackImage)) and BackGround then begin
    DrawTimage.Canvas.Brush.Bitmap := BackImage;
    DrawTimage.Canvas.FillRect(DrawTimage.ClientRect);
  end;


  //TGPBitmap̃rbg}bvf[^擾
  if SrcGPBitmap.LockBits(MakeRect(0, 0, LSrcImgWidth, LSrcImgHeight),
             ImageLockModeRead, PixelFormat32bppARGB, LBmpData) <> Ok then exit;

  //sNZƃObh`悷TBitmap쐬
  //ɕ`悵TImageCanvasɕ`悷
  LImgBitmap := TBitmap.Create;
  try
    LImgBitmap.SetSize(LImgWidth, LImgHeight);
    LImgBitmap.PixelFormat := pf32bit;
    //AlphaFormat := afIgnoredƂĂ
    //afIgnoredɂȂĔ̃sNZɕ`łȂ
    //TImage.Canvasɕ`悷鎞afDefinedɂ
    LImgBitmap.AlphaFormat := afIgnored;

    LScanLine   := LBmpData.Scan0;
    LDataStride := LBmpData.Stride;

    //Obh̐FRGBl擾Ă
    LGridRValue := GetRValue(GridLineColor);
    LGridGValue := GetGValue(GridLineColor);
    LGridBValue := GetBValue(GridLineColor);

    for LYPos := 0 to LSrcImgHeight - 1 do begin
      LpRGBQuad := PRGBQuad(LScanLine);
      LImgBitmap.Canvas.Lock;

      for LXPos := 0 to LSrcImgWidth - 1 do begin

        LAValue := LpRGBQuad^.rgbReserved;
        LRValue := LpRGBQuad^.rgbRed;
        LGValue := LpRGBQuad^.rgbGreen;
        LBValue := LpRGBQuad^.rgbBlue;

        for LiiY := 0 to PixelRectSize do begin
          LDstScanArray  := LImgBitmap.ScanLine[LYPos * PixelRectSize + LiiY];

          //̕Obhւ̕`
          for LiiX := 0 to PixelRectSize do begin
            //Obh`悷Wl̎
            if (ShowGridLine) and ((LiiY = 0) or (LiiX = 0) or
              (LiiY = PixelRectSize) or (LiiX = PixelRectSize)) then begin
              LDstScanArray[LXPos * PixelRectSize + LiiX].rgbReserved := $FF;
              LDstScanArray[LXPos * PixelRectSize + LiiX].rgbRed      := LGridRValue;
              LDstScanArray[LXPos * PixelRectSize + LiiX].rgbGreen    := LGridGValue;
              LDstScanArray[LXPos * PixelRectSize + LiiX].rgbBlue     := LGridBValue;
            end else begin
              LDstScanArray[LXPos * PixelRectSize + LiiX].rgbReserved := LAValue;
              LDstScanArray[LXPos * PixelRectSize + LiiX].rgbRed      := LRValue;
              LDstScanArray[LXPos * PixelRectSize + LiiX].rgbGreen    := LGValue;
              LDstScanArray[LXPos * PixelRectSize + LiiX].rgbBlue     := LBValue;
            end;
          end;
        end;

        Inc(LpRGBQuad);
      end;
      Inc(LScanLine, LDataStride);
    end;

    //쐬TBitmapTImageCanvasɕ`
    //AlphaFormat := afDefinedɂĔ摜̃sNZŕ\
    DrawTimage.Picture.Bitmap.SetSize(LImgWidth, LImgHeight);
    LImgBitmap.AlphaFormat := afDefined;
    DrawTimage.Canvas.Draw(0, 0, LImgBitmap);
  finally
    SrcGPBitmap.UnlockBits(LBmpData);
    LImgBitmap.Canvas.Unlock;

    FreeAndNil(LImgBitmap);
  end;
end;

//-----------------------------------------------------------------------------
//  ǂݍ񂾃rbg}bv(TBitmap)摜̃At@l̏
//
//  TGPBitmapTBitmap̃At@`lȂ
//  TBitmap̃At@lTGPBitmap̃At@lɑ
//  At@`ltTBitmapAt@`ltŕ\\ɂ
//  ̃rbg[32bitȏp
//-----------------------------------------------------------------------------
function TForm1.SetAlphaValueFromTBitmap(DstGPBitmap: TGPBitmap;
  SrcBitmap: TBitmap): Boolean;
type
  TRGBQArray = array [0..4095] of RGBQUAD;
  PRGBQArray = ^TRGBQArray;
var
  LImgWidth   : Integer;
  LImgHeight  : Integer;
  LBmpData    : TBitmapData;
  LScanLine   : PByte;
  LpRGBQuad   : PRGBQuad;
  LDataStride : Integer;
  LXPos       : integer;
  LYPos       : Integer;
  LScanArray  : PRGBQArray;
  LAValue     : Byte;
  LRValue     : Byte;
  LGValue     : Byte;
  LBValue     : Byte;
begin
  Result := False;

  LImgWidth  := DstGPBitmap.GetWidth;
  LImgHeight := DstGPBitmap.GetHeight;

  //TGPBitmap̃rbg}bvf[^擾
  if DstGPBitmap.LockBits(MakeRect(0, 0, LImgWidth, LImgHeight), ImageLockModeWrite,
                                 PixelFormat32bppARGB, LBmpData) <> Ok then exit;

  SrcBitmap.Canvas.Lock;

  LScanLine   := LBmpData.Scan0;
  LDataStride := LBmpData.Stride;

  for LYPos := 0 to LImgHeight - 1 do begin
    LpRGBQuad  := PRGBQuad(LScanLine);
    LScanArray := SrcBitmap.ScanLine[LYPos];

    for LXPos := 0 to LImgWidth - 1 do begin

      LAValue := LScanArray[LXPos].rgbReserved;
      LRValue := LScanArray[LXPos].rgbRed;
      LGValue := LScanArray[LXPos].rgbGreen;
      LBValue := LScanArray[LXPos].rgbBlue;

      if MakeColor(LRValue, LGValue, LBValue, LAValue) = 0 then begin
        LpRGBQuad^.rgbReserved := 0;
      end else
      if (LAValue = 0) then begin
        LpRGBQuad^.rgbReserved := $FF;
      end else begin
        LpRGBQuad^.rgbReserved := LScanArray[LXPos].rgbReserved;
      end;
      Inc(LpRGBQuad);
    end;
    Inc(LScanLine, LDataStride);
  end;

  SrcBitmap.Canvas.Unlock;
  DstGPBitmap.UnlockBits(LBmpData);
  Result := True;
end;

//-----------------------------------------------------------------------------
//  w肵F̃sNZʂ̐FɕύX֐
//
//  GDI+ɂTColorMapŐFύXł邪TColorMap̓J[}bv̕ύXȂ̂
//  ʏł͎w肵FłȂsNZ̐FύXꍇ
//-----------------------------------------------------------------------------
function TForm1.ChangeColor(TarGPBitmap: TGPBitmap; OldColor,
  NewColor: TGPColor): Boolean;
var
  LImgWidth   : Integer;
  LImgHeight  : Integer;
  LBmpData    : TBitmapData;
  LScanLine   : PByte;
  LpRGBQuad   : PRGBQuad;
  LDataStride : Integer;
  LXPos       : integer;
  LYPos       : Integer;
  LAValue     : Byte;
  LRValue     : Byte;
  LGValue     : Byte;
  LBValue     : Byte;
  LOldColor   : TGPColor;
begin
  Result := False;

  LImgWidth  := TarGPBitmap.GetWidth;
  LImgHeight := TarGPBitmap.GetHeight;

  //TGPBitmap̃rbg}bvf[^擾
  if TarGPBitmap.LockBits(MakeRect(0, 0, LImgWidth, LImgHeight), ImageLockModeWrite,
                                 PixelFormat32bppARGB, LBmpData) <> Ok then exit;

  LScanLine   := LBmpData.Scan0;
  LDataStride := LBmpData.Stride;

  for LYPos := 0 to LImgHeight - 1 do begin
    LpRGBQuad  := PRGBQuad(LScanLine);

    for LXPos := 0 to LImgWidth - 1 do begin

      LAValue   := LpRGBQuad^.rgbReserved;
      LRValue   := LpRGBQuad^.rgbRed;
      LGValue   := LpRGBQuad^.rgbGreen;
      LBValue   := LpRGBQuad^.rgbBlue;
      LOldColor := MakeColor(LAValue, LRValue, LGValue, LBValue);

      if LOldColor = OldColor then begin
        LpRGBQuad^.rgbReserved := GetAlpha(NewColor);
        LpRGBQuad^.rgbRed      := GetRed(NewColor);
        LpRGBQuad^.rgbGreen    := GetGreen(NewColor);
        LpRGBQuad^.rgbBlue     := GetBlue(NewColor);
      end;
      Inc(LpRGBQuad);
    end;
    Inc(LScanLine, LDataStride);
  end;

  TarGPBitmap.UnlockBits(LBmpData);
  Result := True;
end;
end.
