//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  GDI+ ֌WTv
//  摜̏d˕`̗ - 摜̓\t
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2017N0715 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, GDIPAPI, GDIPOBJ, GDIPUTIL;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Button1: TButton;
    Image2: TImage;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Privat  e 錾 }
    FGPLeftBitmap   : TGPBitmap;
    FGPRightBitmap  : TGPBitmap;
    FGPCopyBitmap   : TGPBitmap;
    FPixelRectSize  : Cardinal;
    FMaxImgPixels   : Integer;
    FPixelGridColor : TColor;
    FBackTBitmap    : TBitmap;
  public
    { Public 錾 }
    procedure DrawPixelColorToTImage(SrcGPBitmap: TGPBitmap; DrawTimage: TImage;
      PixelRectSize: Integer; MaxImgPixels: Integer; GridLineColor: TColor;
      BackImage: TBitmap = nil; ShowGridLine: Boolean = True;
      BackGround: Boolean = True);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

//=============================================================================
//  tH[̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  //wi摜
  FBackTBitmap := TBitmap.Create;
  FBackTBitmap.LoadFromFile('backTexture_02.bmp');


  //Obh̐FƃsNZ̕`TCY
  FPixelGridColor := clGray;
  FPixelRectSize  := 6;
  FMaxImgPixels   := 128;

  //ɕ\摜̓ǂݍ݂TImageւ̕`
  FGPLeftBitmap := TGPBitmap.Create('emotion_smile.png');
  Image1.Left := 10;
  Image1.Top  := 40;
  DrawPixelColorToTImage(FGPLeftBitmap, Image1, FPixelRectSize, FMaxImgPixels,
                         FPixelGridColor, FBackTBitmap);

  //Eɕ\摜̓ǂݍ݂TImageւ̕`
  FGPRightBitmap := TGPBitmap.Create('bullet_down.png');
  Image2.Left := Image1.Left + Image1.Width + 10;
  Image2.Top  := Image1.Top;
  DrawPixelColorToTImage(FGPRightBitmap, Image2, FPixelRectSize, FMaxImgPixels,
                         FPixelGridColor, FBackTBitmap);
end;

//=============================================================================
//  tH[j̏
//=============================================================================
procedure TForm1.FormDestroy(Sender: TObject);
begin
  if Assigned(FGPLeftBitmap) then FreeAndNil(FGPLeftBitmap);
  if Assigned(FGPRightBitmap) then FreeAndNil(FGPRightBitmap);
  if Assigned(FGPCopyBitmap) then FreeAndNil(FGPCopyBitmap);
  if Assigned(FBackTBitmap) then FreeAndNil(FBackTBitmap);
end;

//=============================================================================
//  摜̈ꕔʂ̉摜ɓ\t
//
//  ʂ̉摜ɒړ\t̂ł͂ȂC\tTGPBitmap𐶐ꍇ
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  LCopyLeft   : Integer;
  LCopyTop    : Integer;
  LCopyWidth  : Integer;
  LCopyHeight : Integer;
  LDestLeft   : Integer;
  LDestTop    : Integer;
  LGPGraphic  : TGPGraphics;
begin
  if Assigned(FGPCopyBitmap) then FreeAndNil(FGPCopyBitmap);

  //Rs[̈̐ݒ
  LCopyLeft   := 16;
  LCopyTop    := 16;
  LCopyWidth  := 16;
  LCopyHeight := 16;

  //VKTGPBitmap쐬
  FGPCopyBitmap := TGPBitmap.Create(LCopyWidth, LCopyHeight);
  //ɉEɕ`撆̉摜̈ꕔ`
  LGPGraphic := TGPGraphics.Create(FGPCopyBitmap);
  try
    LGPGraphic.DrawImage(FGPRightBitmap,
                         MakeRect(0, 0, LCopyWidth, LCopyHeight),
                         LCopyLeft,
                         LCopyTop,
                         LCopyWidth,
                         LCopyHeight,
                         UnitPixel);

    //\t̊Jnʒu
    LDestLeft := 2;
    LDestTop  := 5;

    //㉺𔽓]ē\t邱Ƃɂ
    FGPCopyBitmap.RotateFlip(Rotate180FlipX);

    //VKɍ쐬TGPbitmapɕ\̉摜Ɏwʒu`
    FreeAndNil(LGPGraphic);
    LGPGraphic := TGPGraphics.Create(FGPLeftBitmap);
    LGPGraphic.DrawImage(FGPCopyBitmap, LDestLeft, LDestTop);

    //ύXꂽTGPBitmapTImageɕ`
    DrawPixelColorToTImage(FGPLeftBitmap, Image1, FPixelRectSize, FMaxImgPixels,
                           FPixelGridColor, FBackTBitmap);
  finally
    FreeAndNil(LGPGraphic);
  end;
end;

//-----------------------------------------------------------------------------
//  TGPBitmap̊esNZ̐FObh\
//-----------------------------------------------------------------------------
procedure TForm1.DrawPixelColorToTImage(SrcGPBitmap: TGPBitmap;
  DrawTimage: TImage; PixelRectSize: Integer;  MaxImgPixels: Integer;
  GridLineColor: TColor; BackImage: TBitmap = nil; ShowGridLine: Boolean = True;
  BackGround: Boolean = True);
type
  TRGBQArray = array [0..4095] of RGBQUAD;
  PRGBQArray = ^TRGBQArray;
var
  LSrcImgWidth  : Integer;
  LSrcImgHeight : Integer;
  LImgWidth     : Integer;
  LImgHeight    : Integer;
  LBmpData      : TBitmapData;
  LScanLine     : PByte;
  LpRGBQuad     : PRGBQuad;
  LDataStride   : Integer;
  LAValue       : Byte;
  LRValue       : Byte;
  LGValue       : Byte;
  LBValue       : Byte;
  LXPos         : Integer;
  LYPos         : Integer;
  LImgBitmap    : TBitmap;
  LDstScanArray : PRGBQArray;
  LiiX          : Integer;
  LiiY          : Integer;
  LGridRValue   : Byte;
  LGridGValue   : Byte;
  LGridBValue   : Byte;
  LBitmap       : TBitmap;
begin
  DrawTimage.Picture.Assign(nil);

  //摜̃TCY擾
  LSrcImgWidth  := SrcGPBitmap.GetWidth;
  LSrcImgHeight := SrcGPBitmap.GetHeight;
  if LSrcImgWidth > MaxImgPixels  then LSrcImgWidth  := MaxImgPixels;
  if LSrcImgHeight > MaxImgPixels then LSrcImgHeight := MaxImgPixels;

  //Obh\̕`TCY
  LImgWidth  := LSrcImgWidth * PixelRectSize + 1;
  LImgHeight := LSrcImgHeight * PixelRectSize + 1;

  //wi摜̎w肪Ε`
  if (Assigned(BackImage)) and BackGround then begin
    DrawTimage.Canvas.Brush.Bitmap := BackImage;
    DrawTimage.Canvas.FillRect(DrawTimage.ClientRect);
  end;


  //TGPBitmap̃rbg}bvf[^擾
  if SrcGPBitmap.LockBits(MakeRect(0, 0, LSrcImgWidth, LSrcImgHeight),
             ImageLockModeRead, PixelFormat32bppARGB, LBmpData) <> Ok then exit;

  //sNZƃObh`悷TBitmap쐬
  //ɕ`悵TImageCanvasɕ`悷
  LImgBitmap := TBitmap.Create;
  try
    LImgBitmap.SetSize(LImgWidth, LImgHeight);
    LImgBitmap.PixelFormat := pf32bit;
    //AlphaFormat := afIgnoredƂĂ
    //afIgnoredɂȂĔ̃sNZɕ`łȂ
    //TImage.Canvasɕ`悷鎞afDefinedɂ
    LImgBitmap.AlphaFormat := afIgnored;

    LScanLine   := LBmpData.Scan0;
    LDataStride := LBmpData.Stride;

    //Obh̐FRGBl擾Ă
    LGridRValue := GetRValue(GridLineColor);
    LGridGValue := GetGValue(GridLineColor);
    LGridBValue := GetBValue(GridLineColor);

    for LYPos := 0 to LSrcImgHeight - 1 do begin
      LpRGBQuad := PRGBQuad(LScanLine);
      LImgBitmap.Canvas.Lock;

      for LXPos := 0 to LSrcImgWidth - 1 do begin

        LAValue := LpRGBQuad^.rgbReserved;
        LRValue := LpRGBQuad^.rgbRed;
        LGValue := LpRGBQuad^.rgbGreen;
        LBValue := LpRGBQuad^.rgbBlue;

        for LiiY := 0 to PixelRectSize do begin
          LDstScanArray  := LImgBitmap.ScanLine[LYPos * PixelRectSize + LiiY];

          //̕Obhւ̕`
          for LiiX := 0 to PixelRectSize do begin
            //Obh`悷Wl̎
            if (ShowGridLine) and ((LiiY = 0) or (LiiX = 0) or
              (LiiY = PixelRectSize) or (LiiX = PixelRectSize)) then begin
              LDstScanArray[LXPos * PixelRectSize + LiiX].rgbReserved := $FF;
              LDstScanArray[LXPos * PixelRectSize + LiiX].rgbRed      := LGridRValue;
              LDstScanArray[LXPos * PixelRectSize + LiiX].rgbGreen    := LGridGValue;
              LDstScanArray[LXPos * PixelRectSize + LiiX].rgbBlue     := LGridBValue;
            end else begin
              LDstScanArray[LXPos * PixelRectSize + LiiX].rgbReserved := LAValue;
              LDstScanArray[LXPos * PixelRectSize + LiiX].rgbRed      := LRValue;
              LDstScanArray[LXPos * PixelRectSize + LiiX].rgbGreen    := LGValue;
              LDstScanArray[LXPos * PixelRectSize + LiiX].rgbBlue     := LBValue;
            end;
          end;
        end;

        Inc(LpRGBQuad);
      end;
      Inc(LScanLine, LDataStride);
    end;

    //쐬TBitmapTImageCanvasɕ`
    //AlphaFormat := afDefinedɂĔ摜̃sNZŕ\
    DrawTimage.Picture.Bitmap.SetSize(LImgWidth, LImgHeight);
    LImgBitmap.AlphaFormat := afDefined;
    DrawTimage.Canvas.Draw(0, 0, LImgBitmap);
  finally
    SrcGPBitmap.UnlockBits(LBmpData);
    LImgBitmap.Canvas.Unlock;

    FreeAndNil(LImgBitmap);
  end;
end;

end.
